package org.dromara.zhishu.service;

import org.dromara.zhishu.domain.vo.WhiteListVo;
import org.dromara.zhishu.domain.bo.WhiteListBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 白名单Service接口
 *
 * @author yxy
 * @date 2025-06-25
 */
public interface IWhiteListService {

    /**
     * 查询白名单
     *
     * @param id 主键
     * @return 白名单
     */
    WhiteListVo queryById(Long id);

    /**
     * 分页查询白名单列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 白名单分页列表
     */
    TableDataInfo<WhiteListVo> queryPageList(WhiteListBo bo, PageQuery pageQuery);


    List<WhiteListVo> selectAll();

    List<WhiteListVo> selectByIp(String ip);
    /**
     * 查询符合条件的白名单列表
     *
     * @param bo 查询条件
     * @return 白名单列表
     */
    List<WhiteListVo> queryList(WhiteListBo bo);

    /**
     * 新增白名单
     *
     * @param bo 白名单
     * @return 是否新增成功
     */
    Boolean insertByBo(WhiteListBo bo);

    /**
     * 修改白名单
     *
     * @param bo 白名单
     * @return 是否修改成功
     */
    Boolean updateByBo(WhiteListBo bo);

    /**
     * 校验并批量删除白名单信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 清空数据表
     */
    void deleteAll();
}
